<template>
  <div>
    <el-row>
      <!--查询-->
      <el-col :span="24">
      <Form
        v-show="searchOpen"
        inline
        onsubmit="return false"
        :label-width="60"
      >
        <label class="label-sign" />
        <Form-item class="search-item" label="名称:">
          <el-input v-model="formObj.name" placeholder="请输入名称" @keyup.enter.native="_formSearch" clearable/>
        </Form-item>
        <Form-item class="search-item" label="状态:">
          <el-select v-model="formObj.status" clearable style="width:100%">
            <el-option
              v-for="item in statusList"
              :key="item.value"
              :value="item.value"
              :label="item.label"
            />
          </el-select>
        </Form-item>
        <Form-item class="search-btn">
          <el-button type="primary" @click="_formSearch">
            搜索
          </el-button>
        </Form-item>
      </Form>
      </el-col>
      <!--操作-->
      <el-col :span="24">
      <btn-list
        :msg="btn"
        :open="searchOpen"
        :show-search-btn="true"
        class="contHide"
        @on-result-change="_btnClick"
      />
      </el-col>
      <!-- 表格 -->
      <el-col :span="24">
      <element-table
        ref="pageTable"
        :table-height="tableHeight"
        :get-page="getPage"
        :icon-msg="iconMsg"
        :opt-col-width="70"
        @on-result-change="_tableResultChange"
      >
        <el-table-column
          v-for="item in pageColumns"
          :key="item.id"
          sortable
          show-overflow-tooltip
          :prop="item.key"
          :label="item.title"
          :min-width="item.width"
          :fixed="item.fixed?item.fixed:undefined"
        >
          <template slot-scope="scope">
            <a v-if="item.detail" @click.stop="_detailModal(scope.row.id)">{{ scope.row[item.key] }}</a>
            <div v-else-if="item.key==='status'">
              <div v-if="scope.row[item.key]===0" class="red-color">
                禁用
              </div>
              <div v-else class="blue-color">
                正常
              </div>
            </div>
            <div v-else>
              {{ scope.row[item.key] }}
            </div>
          </template>
        </el-table-column>
      </element-table>
      </el-col>
    </el-row>
    <!-- 添加、编辑 -->
    <systemEdit ref="editModal" @on-result-change="_page" />
    <!-- 查看详情 -->
    <systemDetail ref="detailModal" />
  </div>
</template>
<script>
import { sysSystem } from '../../../api'
import systemEdit from './systemEdit.vue'
import systemDetail from './systemDetail.vue'

export default {
  components: {
    systemEdit,
    systemDetail
  },
  data() {
    return {
      searchOpen: false,
      formObj: {
        name: '',
        status: ''
      },
      btn: [{ type: 'success', id: 'sys-system-add', name: '添加' }],
      iconMsg: [{ type: 'pt-edit', id: 'sys-system-edit', name: '编辑' }],
      statusList: [
        {
          value: '0',
          label: '禁用'
        },
        {
          value: '1',
          label: '正常'
        }
      ],
      getPage: {},
      pageColumns: [
        { title: '标题', key: 'title', width: 150, detail: true },
        { title: '名称', key: 'name', width: 200 },
        { title: '状态', key: 'status', width: 120 },
        { title: '主页', key: 'home', width: 200 },
        { title: '图标', key: 'icon', width: 200 },
        { title: '主题', key: 'theme', width: 200 },
        { title: '背景', key: 'banner', width: 200 },
        { title: '排序', key: 'sort', width: 100 },
        { title: '备注', key: 'remark', width: 400 }
      ]
    }
  },
  computed: {
    tableHeight: function() {
      if (this.searchOpen) {
        return this.$tableHeight('search')
      } else {
        return this.$tableHeight('noSearch')
      }
    }
  },
  mounted() {
    this._formSearch()
  },
  methods: {
    _iconClick(res, data) {
      switch (res) {
        case '编辑':
          this._editModal(data.id)
          break
      }
    },
    _page: async function() {
      Object.assign(this.formObj, this.$refs.pageTable._searchParams())
      const result = await sysSystem.page(this.$serializeForm(this.formObj))
      if (result) {
        this.getPage = result
        this.$refs.pageTable._initTable()
      }
    },
    _formSearch() {
      this.$refs.pageTable._pageChange(1)
    },
    _detailModal(id) {
      this.$refs.detailModal._open(id)
    },
    _editModal: async function(id) {
      const result = await sysSystem.getById(id)
      this.$refs.editModal._open(result)
    },
    _btnClick(msg) {
      switch (msg) {
        case '添加':
          this.$refs.editModal._open()
          break
        case 'search':
          this.searchOpen = !this.searchOpen
          break
      }
    },
    _tableResultChange(msg, data) {
      switch (msg) {
        case 'page':
          this._page()
          break
        case 'iconClick':
          this._iconClick(data.name, data.rowData)
          break
      }
    }
  }
}
</script>
